-- Copyright (C) 2017 James Jonathan Cook
-- This program is distributed under the terms of the GNU Lesser General Public License.
--
-- This program was written by James Jonathan Cook (jmsck55@gmail.com)
--
--    This program is free software: you can redistribute it and/or modify
--    it under the terms of the GNU Lesser General Public License as published by
--    the Free Software Foundation, either version 3 of the License, or
--    (at your option) any later version.
--
--    This program is distributed in the hope that it will be useful,
--    but WITHOUT ANY WARRANTY; without even the implied warranty of
--    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--    GNU Lesser General Public License for more details.
--
--    You should have received a copy of the GNU Lesser General Public License
--    along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--

-- with trace
-- trace(1)

public constant TRUE = 1, FALSE = 0

public integer ANCIENT_ROMAN = FALSE
-- public integer AncientRoman = TRUE

public sequence number_values = {
	{'I', 1},
	{'V', 5},
	{'X', 10},
	{'L', 50},
	{'C', 100},
	{'D', 500},
	{'M', 1000}
}

public function number_roman_to_modern(sequence st)
	atom number
	integer val, f
	val = 0
	number = 0
	
	for i = length(st) to 1 by -1 do
		f = 0
		for j = 1 to length(number_values) do
			if number_values[j][1] = st[i] then
				f = number_values[j][2]
			end if
		end for
		if f = 0 then
			return "not supported"
		end if
		if val != f and val > f then
			val = -f
		else
			val = f
		end if
		number += val
	end for
	
	return number - ANCIENT_ROMAN
end function

-- public function number_modern_to_roman(atom number)
-- 	atom test, tmp
-- 	sequence st, buffer
-- 	number += ANCIENT_ROMAN
-- 	st = ""
-- 	buffer = ""
-- 	tmp = 0
-- 	while number > 0 do
-- 		for i = length(number_values) to 1 by -1 do
-- 			if number >= number_values[i][2] then
-- 				number -= number_values[i][2]
-- 				buffer = append(buffer, number_values[i][1])
-- 			end if
-- 		end for
-- 		--NOTE: Still working on this...
-- 		--st = st & buffer
-- 	end while
-- 	st = buffer
-- 	return st
-- end function

--? number_roman_to_modern("XX")
--printf(1, "%s\n", {number_modern_to_roman(4)})
--end of file.
